#include "pgm.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h> /* funciones de clasificación de caracteres */

int skip_comments(FILE *fp)
{
    int ch;
    char line[100];

    while ((ch = fgetc(fp)) != EOF && isspace(ch)) 
        ;
    if (ch == '#') {
        fgets(line, sizeof(line), fp);
        skip_comments(fp);
    } else
        fseek(fp, -1, SEEK_CUR);
    return 0;
}

int leer_archivo_pgm(char ruta_archivo[], int pixeles_in[]) {
  int res;
  int i,n;
  int ancho,alto,maxval;
  FILE* fhandle;
  fhandle = fopen(ruta_archivo,"r");
  if (fhandle == NULL) {
    printf("Error al abrir archivo %s\n",ruta_archivo);
    res = ferror(fhandle);
    return res;
  } else {
   /* ya leemos toda la metadata */    
    if ((fgetc(fhandle) != 'P') || (fgetc(fhandle) != '2')) {
      fclose(fhandle);
      printf("Error: esta biblioteca sólo puede leer PGM tipo P2\n");
      return PGM_ERROR;
    }
    res = skip_comments(fhandle); if (res) return PGM_ERROR;
    res = fscanf(fhandle, "%d", &ancho); if (res <=0) return PGM_ERROR;
    res = skip_comments(fhandle); if (res) return PGM_ERROR;
    res = fscanf(fhandle, "%d", &alto); if (res <= 0) return PGM_ERROR;
    res = skip_comments(fhandle); if (res) return PGM_ERROR;
    res = fscanf(fhandle, "%d", &maxval); if (res <= 0) return PGM_ERROR;
    res = skip_comments(fhandle); if (res) return PGM_ERROR;
    /* fgetc(fhandle); */ /* un caracter de separacion antes de los datos */
    if ((ancho != ANCHO) || (alto != ALTO) || (maxval > MAXVAL)) {
      printf("Solo se pueden leer imagenes de 512x340 y valor maximo 255 (o menor)\n");
      return PGM_ERROR;
    }
    n = ancho*alto;
    for (i = 0; i < n; ++i) {
      res = fscanf(fhandle,"%d",&pixeles_in[i]);
      if (res != 1) {
	printf("Error al leer pixel %d dearchivo %s\n",i,ruta_archivo);
        return PGM_ERROR;
      }
    }
    return PGM_OK;
  }
}

int escribir_archivo_pgm(int pixels[], int ancho, int alto, int maxval, char ruta_archivo[]) {
  int i,j;
  FILE* fw;

  fw = fopen(ruta_archivo, "wb"); 
  if (fw == NULL) {
    i = ferror(fw);
    fclose(fw);
    printf("Error al intentar escribir archivo %s\n",ruta_archivo);
    return i;
  }
  fprintf(fw, "P2\n"); /*Escribimos el número mágico*/
  fprintf(fw, "%d %d\n", ancho, alto);
  fprintf(fw, "%d\n", maxval);
    for (i = 0; i < alto; ++i) {
      for (j = 0; j < ancho; ++j) {
	fprintf(fw,"%d\t",pixels[i*ancho+j]);
      }
      fprintf(fw,"\n");
    }
  i = fclose(fw);
  return i;
}
